/* Tecnisa - Tecnologia em Informtica

 Nome: 0316_CUSFUN_CUSTO_PRODUTO

 Descrio:
 Funo para clculo do custo do produto de acordo com a tabela TIPOCUSTO
_________________________________________________________________________
_________________________________________________________________________
   01 Custo Mdio Lquido Atual
   02 Custo Mdio Bruto Atual
   03 Custo Mdio Lquido da poca
   04 Custo Mdio Bruto da poca
   06 Custo de Cotao (Lista de Preos)
   07 Custo da ltima compra(AF)
   08 Custo Lquido da poca (ltima Compra)
   09 Custo Bruto da poca (ltima Compra)
   10 Custo de Cotao(Lista de Preos com Imposto)
   20 Custo Mdio Lquido Atual
   21 Custo Mdio Lquido Atual
   22 Custo Mdio Bruto Atual
   23 Custo Mdio Bruto Atual
   24 Custo Mdio Lquido da poca
   25 Custo Mdio Lquido da poca
   26 Custo Mdio Bruto da poca
   27 Custo Mdio Bruto da poca
   28 Custo da ltima Compra (NF)
   29 Custo da ltima Compra (NF)
   30 Custo de Cotao (Lista de Preos)
   31 Custo de Cotao (Lista de Preos)
   32 Custo da ltima Compra(AF)
   33 Custo da ltima Compra(AF)
   34 Custo Mdio Atualizado
   35 Custo Mdio Atualizado
   40 Custo Mdio Lquido Atual(Logstica)
   41 Custo Mdio Bruto Atual(Logstica)
   42 Custo Mdio Lquido da poca(Logstica)
   43 Custo Mdio Bruto da poca(Logstica)
   44 Custo de Cotao (Lista de Preos - Logstica)
   45 Custo da ltima compra(AF-Logstica)
   46 Custo de Compra Liquido da poca(Logstica)
   47 Custo de Compra Bruto da poca(Logstica)
   48 Custo de Cotao-Lista de Preo Imposto(Logstica)
   49 Custo Mdio Lquido Atual(Logstca)
   50 Custo Mdio Lquido Atual(Logstica)
   51 Custo Mdio Bruto Atual(Logstica)
   52 Custo Mdio Bruto Atual(Logstica)
   53 Custo Mdio Lquido da poca(Logstica)
   54 Custo Mdio Lquido da poca(Logstica)
   55 Custo Mdio Bruto da poca(Logstica)
   56 Custo Mdio Bruto da poca(Logstica)
   57 Custo da ltima Compra (NF - Logstica)
   58 Custo da ltima Compra (NF - Logstica)
   59 Custo da ltima Compra(AF - Logstica)
   60 Custo da ltima Compra(AF - Logstica)
   61 Custo de Cotao (Lista de Preos - Logstica)
   62 Custo de Cotao (Lista de Preos - Logstica)
   63 Custo Mdio Contbil
   64 Custo Objetivo
_________________________________________________________________________
_________________________________________________________________________

 Criao:
 13/10/2003 - Roberto A. Lopes Martins

 @C:\Win_Prj\Sql\End_Conv\Sql Server\0316_CUSFUN_CUSTO_PRODUTO.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CUSTO_PRODUTO' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CUSTO_PRODUTO
GO
CREATE FUNCTION CUSTO_PRODUTO(
   @P_CDFILIAL     VARCHAR(4),
   @P_CDPRODUTO    VARCHAR(10),
   @P_NRTIPOCUSTO  INT,
   @P_DTREFERENCIA DATETIME,
   @P_DTATUAL      DATETIME) RETURNS NUMERIC(10,5)
AS
BEGIN
   DECLARE @V_VRCUSTO        DOUBLE PRECISION;
   DECLARE @V_SEM_IMPOSTO    DOUBLE PRECISION;
   DECLARE @V_DTREFERENCIA   DATETIME;
   DECLARE @V_DTPOSICAO      DATETIME;

   DECLARE @V_QTESTDIACON    DOUBLE PRECISION;
   DECLARE @V_QTESTANTCON    DOUBLE PRECISION;
   DECLARE @V_VRESTDIACON    DOUBLE PRECISION;
   DECLARE @V_VRESTDIACOM1   DOUBLE PRECISION;
   DECLARE @V_VRESTDIACOM2   DOUBLE PRECISION;
   DECLARE @V_VRESTANTCON    DOUBLE PRECISION;
   DECLARE @V_VRESTANTCOM1   DOUBLE PRECISION;
   DECLARE @V_VRESTANTCOM2   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCON   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCM1   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCM2   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCON   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCM1   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCM2   DOUBLE PRECISION;

   DECLARE @V_VRULTCOMPR     DOUBLE PRECISION;
   DECLARE @V_VRULTCOMPRM1   DOUBLE PRECISION;
   DECLARE @V_VRULTCOMPRM2   DOUBLE PRECISION;

   DECLARE @V_VRCUSPRLISTP   DOUBLE PRECISION;
   DECLARE @V_VRCUSPRLISM1   DOUBLE PRECISION;
   DECLARE @V_VRCUSPRLISM2   DOUBLE PRECISION;
   DECLARE @V_VRCUSLIPRIMP   DOUBLE PRECISION;
   DECLARE @V_VRPRCUSTOAF    DOUBLE PRECISION;
   DECLARE @V_VRPRCUSAFM1    DOUBLE PRECISION;
   DECLARE @V_VRPRCUSAFM2    DOUBLE PRECISION;
   DECLARE @V_IDUTILDTPROC   VARCHAR(1);

/*CUSTO LOGISTICO*/
   DECLARE @V_VRCLOGCON      DOUBLE PRECISION;
   DECLARE @V_VRCLOGCONANT   DOUBLE PRECISION;
   DECLARE @V_VRCLOGCONM1    DOUBLE PRECISION;
   DECLARE @V_VRCLOGCONAM1   DOUBLE PRECISION;
   DECLARE @V_VRCLOGCONM2    DOUBLE PRECISION;
   DECLARE @V_VRCLOGCONAM2   DOUBLE PRECISION;
   DECLARE @V_VRSEGUCON      DOUBLE PRECISION;
   DECLARE @V_VRSEGUCONANT   DOUBLE PRECISION;
   DECLARE @V_VRSEGUCONM1    DOUBLE PRECISION;
   DECLARE @V_VRSEGUCONAM1   DOUBLE PRECISION;
   DECLARE @V_VRSEGUCONM2    DOUBLE PRECISION;
   DECLARE @V_VRSEGUCONAM2   DOUBLE PRECISION;

   DECLARE @V_VRPESOBRUTPR   DOUBLE PRECISION;
   DECLARE @V_VRPECUSTOLOG   DOUBLE PRECISION;
   DECLARE @V_VRVRCUSTOLOG   DOUBLE PRECISION;
   DECLARE @V_VRPESEGURLOG   DOUBLE PRECISION;
   DECLARE @V_VRCUSTOLOG     DOUBLE PRECISION;
   DECLARE @V_VRCUSTOSEG     DOUBLE PRECISION;
   DECLARE @V_VRLIQCMPPROD   DOUBLE PRECISION;
   DECLARE @V_VRBRUCMPPROD   DOUBLE PRECISION;
   DECLARE @V_VRLIQCMPPRM1   DOUBLE PRECISION;
   DECLARE @V_VRLIQCMPPRM2   DOUBLE PRECISION;
   DECLARE @V_VRCUSTLOGCMP   DOUBLE PRECISION;
   DECLARE @V_VRCUSTLCMPM1   DOUBLE PRECISION;
   DECLARE @V_VRCUSTLCMPM2   DOUBLE PRECISION;
   DECLARE @V_VRSEGULOGCMP   DOUBLE PRECISION;
   DECLARE @V_VRSEGULCMPM1   DOUBLE PRECISION;
   DECLARE @V_VRSEGULCMPM2   DOUBLE PRECISION;
   DECLARE @V_CDFORNCUSTAF   VARCHAR(21);
   DECLARE @V_CDPRODCUSTAF   VARCHAR(10);
   DECLARE @V_CDPRODACOR     VARCHAR(10);
   DECLARE @V_CDPRODLIST     VARCHAR(10);
   DECLARE @V_FORNECEDOR     VARCHAR(21);
   DECLARE @V_CDFORNECACOR   VARCHAR(21);
   DECLARE @V_CDFORNECLIST   VARCHAR(21);
   DECLARE @V_CDFORNEOL      VARCHAR(21);
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_CDFILIAL       VARCHAR(04);
   DECLARE @V_VRFATOCONV     DOUBLE PRECISION;

   DECLARE @V_IDUTILCONSSOLIOL VARCHAR(1);

   SET  @V_VRCUSTO      = 0;
   SET  @V_VRCLOGCON    = 0;
   SET  @V_VRCLOGCONANT = 0;
   SET  @V_VRCLOGCONM1  = 0;
   SET  @V_VRCLOGCONAM1 = 0;
   SET  @V_VRCLOGCONM2  = 0;
   SET  @V_VRCLOGCONAM2 = 0;
   SET  @V_VRSEGUCON    = 0;
   SET  @V_VRSEGUCONANT = 0;
   SET  @V_VRSEGUCONM1  = 0;
   SET  @V_VRSEGUCONAM1 = 0;
   SET  @V_VRSEGUCONM2  = 0;
   SET  @V_VRSEGUCONAM2 = 0;

   SET  @V_VRPESOBRUTPR = 0;
   SET  @V_VRPECUSTOLOG = 0;
   SET  @V_VRVRCUSTOLOG = 0;
   SET  @V_VRPESEGURLOG = 0;
   SET  @V_VRCUSTOLOG   = 0;
   SET  @V_VRCUSTOSEG   = 0;
   SET  @V_VRLIQCMPPROD = 0;
   SET  @V_VRBRUCMPPROD = 0;
   SET  @V_VRLIQCMPPRM1 = 0;
   SET  @V_VRLIQCMPPRM2 = 0;
   SET  @V_VRCUSTLOGCMP = 0;
   SET  @V_VRCUSTLCMPM1 = 0;
   SET  @V_VRCUSTLCMPM2 = 0;
   SET  @V_VRSEGULOGCMP = 0;
   SET  @V_VRSEGULCMPM1 = 0;
   SET  @V_VRSEGULCMPM2 = 0;

   SET @V_IDUTILCONSSOLIOL = '';


   IF @P_NRTIPOCUSTO IN (1,2,3,4,20,21,22,23,24,25,26,27,40,41,42,43,49,50,53,54) BEGIN /*Custos que tem valores na tabela POSESTCONS*/

      IF (@P_NRTIPOCUSTO IN (1,2,20,21,22,23,40,41,49,50,51,52)) BEGIN         /*Custo Mdio Atual*/
         SELECT @V_IDUTILDTPROC = ISNULL(IDUTILDTPROC, 'N')
         FROM PARAMGERAL
         WHERE CDPARGERAL = '0001';
         IF @V_IDUTILDTPROC = 'N' BEGIN
            SET @V_DTREFERENCIA = @P_DTATUAL;
         END
         ELSE BEGIN
            SELECT @V_DTREFERENCIA = ISNULL(DTPROCESSA, @P_DTATUAL)
            FROM PARAMFILIAL P
            WHERE CDFILIAL = @P_CDFILIAL;
         END;
      END
      ELSE BEGIN                                             /*Custo Mdio da poca*/
         SET @V_DTREFERENCIA = @P_DTREFERENCIA;
      END;

      SELECT @V_DTPOSICAO = MAX(DTPOSESTCON)
      FROM POSESTCONS PD
      WHERE CDFILIAL  = @P_CDFILIAL  AND
            CDPRODUTO = @P_CDPRODUTO AND
            DTPOSESTCON <= @V_DTREFERENCIA + 1;

      SELECT @V_QTESTDIACON  = ISNULL(MAX(QTESTDIACON),0),
             @V_QTESTANTCON  = ISNULL(MAX(QTESTANTCON),0),
             @V_VRESTDIACON  = ISNULL(MAX(VRESTDIACON),0),
             @V_VRESTDIACOM1 = ISNULL(MAX(VRESTDIACOM1),0),
             @V_VRESTDIACOM2 = ISNULL(MAX(VRESTDIACOM2),0),
             @V_VRESTANTCON  = ISNULL(MAX(VRESTANTCON),0),
             @V_VRESTANTCOM1 = ISNULL(MAX(VRESTANTCOM1),0),
             @V_VRESTANTCOM2 = ISNULL(MAX(VRESTANTCOM2),0),
             @V_VRESTBRUTCON = ISNULL(MAX(VRESTBRUTCON),0),
             @V_VRESTBRUTCM1 = ISNULL(MAX(VRESTBRUTCM1),0),
             @V_VRESTBRUTCM2 = ISNULL(MAX(VRESTBRUTCM2),0),
             @V_VRBRUTANTCON = ISNULL(MAX(VRBRUTANTCON),0),
             @V_VRBRUTANTCM1 = ISNULL(MAX(VRBRUTANTCM1),0),
             @V_VRBRUTANTCM2 = ISNULL(MAX(VRBRUTANTCM2),0),
             @V_VRCLOGCON    =  ISNULL(MAX(VRCLOGCON),0),
             @V_VRCLOGCONANT =  ISNULL(MAX(VRCLOGCONANT),0),
             @V_VRCLOGCONM1  =  ISNULL(MAX(VRCLOGCONM1),0),
             @V_VRCLOGCONAM1 =  ISNULL(MAX(VRCLOGCONAM1),0),
             @V_VRCLOGCONM2  =  ISNULL(MAX(VRCLOGCONM2),0),
             @V_VRCLOGCONAM2 =  ISNULL(MAX(VRCLOGCONAM2),0),
             @V_VRSEGUCON    =  ISNULL(MAX(VRSEGUCON),0),
             @V_VRSEGUCONANT =  ISNULL(MAX(VRSEGUCONANT),0),
             @V_VRSEGUCONM1  =  ISNULL(MAX(VRSEGUCONM1),0),
             @V_VRSEGUCONAM1 =  ISNULL(MAX(VRSEGUCONAM1),0),
             @V_VRSEGUCONM2  =  ISNULL(MAX(VRSEGUCONM2),0),
             @V_VRSEGUCONAM2 =  ISNULL(MAX(VRSEGUCONAM2),0)
      FROM POSESTCONS P
      WHERE CDFILIAL    = @P_CDFILIAL  AND
            CDPRODUTO   = @P_CDPRODUTO AND
            DTPOSESTCON = @V_DTPOSICAO;

      IF (@V_QTESTDIACON <> 0) BEGIN
         SET @V_VRESTDIACON  = (@V_VRESTDIACON/@V_QTESTDIACON);
         SET @V_VRESTDIACOM1 = (@V_VRESTDIACOM1/@V_QTESTDIACON);
         SET @V_VRESTDIACOM2 = (@V_VRESTDIACOM2/@V_QTESTDIACON);
         SET @V_VRESTBRUTCON = (@V_VRESTBRUTCON/@V_QTESTDIACON);
         SET @V_VRESTBRUTCM1 = (@V_VRESTBRUTCM1/@V_QTESTDIACON);
         SET @V_VRESTBRUTCM2 = (@V_VRESTBRUTCM2/@V_QTESTDIACON);

         SET @V_VRCLOGCON    = (@V_VRCLOGCON/@V_QTESTDIACON);
         SET @V_VRCLOGCONM1  = (@V_VRCLOGCONM1/@V_QTESTDIACON);
         SET @V_VRCLOGCONM2  = (@V_VRCLOGCONM2/@V_QTESTDIACON);
         SET @V_VRSEGUCON    = (@V_VRSEGUCON/@V_QTESTDIACON);
         SET @V_VRSEGUCONM1  = (@V_VRSEGUCONM1/@V_QTESTDIACON);
         SET @V_VRSEGUCONM2  = (@V_VRSEGUCONM2/@V_QTESTDIACON);
      END
      ELSE BEGIN
        IF (@V_QTESTANTCON <> 0) BEGIN
           SET @V_VRESTDIACON  = (@V_VRESTANTCON/@V_QTESTANTCON);
           SET @V_VRESTDIACOM1 = (@V_VRESTANTCOM1/@V_QTESTANTCON);
           SET @V_VRESTDIACOM2 = (@V_VRESTANTCOM2/@V_QTESTANTCON);
           SET @V_VRESTBRUTCON = (@V_VRBRUTANTCON/@V_QTESTANTCON);
           SET @V_VRESTBRUTCM1 = (@V_VRBRUTANTCM1/@V_QTESTANTCON);
           SET @V_VRESTBRUTCM2 = (@V_VRBRUTANTCM2/@V_QTESTANTCON);

           SET @V_VRCLOGCON    = (@V_VRCLOGCONANT/@V_QTESTANTCON);
           SET @V_VRCLOGCONM1  = (@V_VRCLOGCONAM1/@V_QTESTANTCON);
           SET @V_VRCLOGCONM2  = (@V_VRCLOGCONAM2/@V_QTESTANTCON);
           SET @V_VRSEGUCON    = (@V_VRSEGUCONANT/@V_QTESTANTCON);
           SET @V_VRSEGUCONM1  = (@V_VRSEGUCONAM1/@V_QTESTANTCON);
           SET @V_VRSEGUCONM2  = (@V_VRSEGUCONAM2/@V_QTESTANTCON);
        END
        ELSE BEGIN
           SET @V_VRESTDIACON  = 0;
           SET @V_VRESTDIACOM1 = 0;
           SET @V_VRESTDIACOM2 = 0;
           SET @V_VRESTBRUTCON = 0;
           SET @V_VRESTBRUTCM1 = 0;
           SET @V_VRESTBRUTCM2 = 0;
           SET @V_VRCLOGCON    = 0;
           SET @V_VRCLOGCONM1  = 0;
           SET @V_VRCLOGCONM2  = 0;
           SET @V_VRSEGUCON    = 0;
           SET @V_VRSEGUCONM1  = 0;
           SET @V_VRSEGUCONM2  = 0;
        END;
      END;

      IF @P_NRTIPOCUSTO IN (1,3,40,42) BEGIN      /*Custo Mdio Lquido*/
         SET @V_VRCUSTO = @V_VRESTDIACON;
         IF @P_NRTIPOCUSTO IN (40,42) BEGIN /*Custo Mdio Lquido(Logistico)*/
            SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCON+ @V_VRSEGUCON;
         END;
      END
      ELSE BEGIN
        IF @P_NRTIPOCUSTO IN (2,4,41,43) BEGIN   /*Custo Mdio Bruto*/
           SET @V_VRCUSTO = @V_VRESTBRUTCON;
           IF @P_NRTIPOCUSTO IN (41,43) BEGIN  /*Custo Mdio Bruto(Logistico)*/
              SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCON + @V_VRSEGUCON;
           END;
        END
        ELSE BEGIN
          IF @P_NRTIPOCUSTO IN (20,24,49,53) BEGIN /*Custo Mdio Lquido (ndice 01)*/
             SET @V_VRCUSTO = @V_VRESTDIACOM1;
          IF @P_NRTIPOCUSTO IN (49,53) BEGIN  /*Custo Mdio Lquido(Logistico) Indice 01*/
             SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCONM1+@V_VRSEGUCONM1;
          END;

          END
          ELSE BEGIN
            IF @P_NRTIPOCUSTO IN (21,25,40,54) BEGIN /*Custo Mdio Lquido (ndice 02)*/
               SET @V_VRCUSTO = @V_VRESTDIACOM2;
               IF @P_NRTIPOCUSTO IN (40,54) BEGIN  /*Custo Mdio Lquido(Logistico) Indice 02*/
                  SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCONM2+ @V_VRSEGUCONM2;
               END;
            END
            ELSE BEGIN
              IF @P_NRTIPOCUSTO IN (22,26,51,55) BEGIN /*Custo Mdio Bruto (ndice 01)*/
                 SET @V_VRCUSTO = @V_VRESTBRUTCM1;
                 IF @P_NRTIPOCUSTO IN (51,55) BEGIN  /*Custo Mdio Bruto(Logistico) Indice 01*/
                    SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCONM1+@V_VRSEGUCONM1;
                 END;
              END
              ELSE BEGIN
                IF @P_NRTIPOCUSTO IN (23,27,52,56) BEGIN /*Custo Mdio Bruto (ndice 02)*/
                   SET @V_VRCUSTO = @V_VRESTBRUTCM2;
                   IF @P_NRTIPOCUSTO IN (52,56) BEGIN  /*Custo Mdio Bruto(Logistico) Indice 02*/
                      SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCLOGCONM2+@V_VRSEGUCONM2;
                   END;
                END;
              END;
            END;
          END;
        END;
      END;
   END
   ELSE BEGIN
      IF @P_NRTIPOCUSTO IN (6,7,10,30,31,32,33,44,48,45,59,60,61,62) BEGIN /*Custos que tem valores na tabela CUSTOSUP*/
         SET @V_CDFORNEOL = NULL;
         IF @P_NRTIPOCUSTO IN (44, 45, 48, 59, 60, 61, 62) BEGIN
            SELECT @V_IDUTILCONSSOLIOL = P.IDUTILCONSSOLIOL
              FROM PARASUPRI P, FILIAL F
             WHERE F.CDFILIAL = @P_CDFILIAL
               AND P.CDFILIAL = F.CDFILCENTCMP;
            IF @V_IDUTILCONSSOLIOL = 'S' BEGIN
               SELECT
                  @V_CDFILIAL = MAX(P.CDFILIOPELOG)
               FROM
                  PARAMPRODSUP P
               WHERE
                  P.CDFILIAL  = @P_CDFILIAL AND
                  P.CDPRODUTO = @P_CDPRODUTO;
               IF @V_CDFILIAL IS NULL BEGIN
                  SET @V_CDFILIAL = @P_CDFILIAL;
               END
               ELSE BEGIN
                  SELECT
                     @V_CDFORNEOL = MAX(FILIAL.CDFORNOPELOG)
                  FROM
                     FILIAL
                  WHERE
                     FILIAL.CDFILIAL = @V_CDFILIAL;
               END;
            END
            ELSE BEGIN
               SET @V_CDFILIAL = @P_CDFILIAL;
            END;
         END
         ELSE BEGIN
            SET @V_CDFILIAL = @P_CDFILIAL;
         END;

         IF @P_NRTIPOCUSTO IN (6, 10, 30, 31, 44, 48, 61, 62) BEGIN
            SELECT
               @V_VRCUSPRLISTP = ISNULL(MAX(VRCUSPRLISTP),0),
               @V_VRCUSPRLISM1 = ISNULL(MAX(VRCUSPRLISM1),0),
               @V_VRCUSPRLISM2 = ISNULL(MAX(VRCUSPRLISM2),0),
               @V_VRCUSLIPRIMP = ISNULL(MAX(VRCUSLIPRIMP),0),
               @V_CDPRODACOR   = MAX(CDPRODACOR),
               @V_CDPRODLIST   = MAX(CDPRODLIST),
               @V_CDFORNECLIST = MAX(CDFORNECLIST),
               @V_CDFORNECACOR = MAX(CDFORNECACOR)
            FROM CUSTOSUP
            WHERE CDFILIAL   = @V_CDFILIAL  AND
                  CDPRODUTO  = @P_CDPRODUTO AND
                  DTCUSTOSUP = (SELECT MAX(DTCUSTOSUP)
                                FROM CUSTOSUP
                                WHERE CDFILIAL  = @V_CDFILIAL  AND
                                      CDPRODUTO = @P_CDPRODUTO AND
                                      VRCUSPRLISTP IS NOT NULL AND
                                      DTCUSTOSUP <= @P_DTREFERENCIA);
         END;

         IF @P_NRTIPOCUSTO IN (7, 32, 33, 45, 59, 60) BEGIN
            SELECT
               @V_VRPRCUSTOAF  = ISNULL(MAX(VRPRCUSTOAF),0),
               @V_VRPRCUSAFM1  = ISNULL(MAX(VRPRCUSAFM1),0),
               @V_VRPRCUSAFM2  = ISNULL(MAX(VRPRCUSAFM2),0),
               @V_CDFORNCUSTAF = MAX(CDFORNCUSTAF),
               @V_CDPRODCUSTAF = MAX(CDPRODCUSTAF)
            FROM CUSTOSUP
            WHERE CDFILIAL   = @V_CDFILIAL  AND
                  CDPRODUTO  = @P_CDPRODUTO AND
                  DTCUSTOSUP = (SELECT MAX(DTCUSTOSUP)
                                FROM CUSTOSUP
                                WHERE CDFILIAL  = @V_CDFILIAL  AND
                                      CDPRODUTO = @P_CDPRODUTO AND
                                      VRPRCUSTOAF IS NOT NULL AND
                                      DTCUSTOSUP <= @P_DTREFERENCIA);
         END;

 /*      Lista de preo e cotao(Logistico)    [06,10][44,48]*/

         IF (@V_CDPRODACOR IS NOT NULL) BEGIN
            SET @V_CDPRODUTO   = @V_CDPRODACOR;
            SET @V_FORNECEDOR  = @V_CDFORNECACOR;
         END;

         IF (@V_CDPRODLIST IS NOT NULL) BEGIN
            SET @V_CDPRODUTO    = @V_CDPRODLIST;
            SET @V_FORNECEDOR   = @V_CDFORNECLIST;
         END;

         IF (@V_CDPRODCUSTAF IS NOT NULL) BEGIN
            SET @V_CDPRODUTO    = @V_CDPRODCUSTAF;
            SET @V_FORNECEDOR   = @V_CDFORNCUSTAF;
         END;

         IF @P_NRTIPOCUSTO IN (44, 45, 48, 59, 60,61,62) BEGIN
            SELECT
               @V_VRFATOCONV = ISNULL(MAX(VRFATOCONV), 1)
            FROM
               PRODUTO
            WHERE
               PRODUTO.CDPRODUTO = @V_CDPRODUTO;

            SELECT
               @V_VRPESOBRUTPR = X.VRPESOBRUTPR,
               @V_VRPECUSTOLOG = C.VRPECUSTOLOG,
               @V_VRVRCUSTOLOG = C.VRVRCUSTOLOG,
               @V_VRPESEGURLOG = C.VRPESEGURLOG
            FROM
               PRODUTO P,
               CUSTOLOGIST C,
               (SELECT
                   ISNULL(MAX(A.VRPESOBRUTPR),0) VRPESOBRUTPR,
                      MAX(P.CDARVPROD) CDPRODUTO,
                      MAX(C.DTINIVIGCLOG) DTINIVIGCLOG
                FROM
                   PRODUTO P,
                   CUSTOLOGIST C,
                   PRODUTO A
                WHERE
                   (CHARINDEX(P.CDARVPROD, A.CDARVPROD) = 1)       AND
                   A.CDPRODUTO    = @V_CDPRODUTO                   AND
                   P.CDPRODUTO    = C.CDPRODUTO                    AND
                   C.CDFILIAL     = @P_CDFILIAL                    AND
                   C.CDFORNECED   = ISNULL(@V_CDFORNEOL, @V_FORNECEDOR) AND
                   C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                     FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                     WHERE
                                        A.CDFILIAL     = C.CDFILIAL                AND
                                        A.CDFORNECED   = C.CDFORNECED              AND
                                        (CHARINDEX(Q.CDARVPROD, B.CDARVPROD) = 1)  AND
                                        B.CDPRODUTO    = @V_CDPRODUTO              AND
                                        Q.CDPRODUTO    = A.CDPRODUTO               AND
                                        A.DTINIVIGCLOG <= @P_DTREFERENCIA))X
            WHERE C.CDFILIAL     = @P_CDFILIAL                         AND
                  C.CDPRODUTO    = P.CDPRODUTO                         AND
                  C.CDPRODUTO    = X.CDPRODUTO                         AND
                  C.CDFORNECED   = ISNULL(@V_CDFORNEOL, @V_FORNECEDOR) AND
                  C.DTINIVIGCLOG = X.DTINIVIGCLOG;
         END;
         IF @V_VRFATOCONV IS NULL BEGIN
            SET @V_VRFATOCONV = 1;
         END;

         IF @P_NRTIPOCUSTO IN (6,44) BEGIN           /*Custo de Cotao (Lista de Preos)*/
            SET @V_VRCUSTO = @V_VRCUSPRLISTP;
            IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
               IF @P_NRTIPOCUSTO = 44  BEGIN
                  IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                  END;

                  IF (@V_VRPECUSTOLOG > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                  END;

                  IF (@V_VRPESEGURLOG > 0) BEGIN
                     SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                  END;

                  SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
               END;
            END;
         END
         ELSE BEGIN
            IF @P_NRTIPOCUSTO IN (7,45) BEGIN        /*Custo da ltima compra(AF)*/
               SET @V_VRCUSTO = @V_VRPRCUSTOAF;
               IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                  IF @P_NRTIPOCUSTO = 45  BEGIN
                     IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                        SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                     END;

                     IF (@V_VRPECUSTOLOG > 0) BEGIN
                        SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                     END;

                     IF (@V_VRPESEGURLOG > 0) BEGIN
                        SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                     END;

                     SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                  END;
               END;
            END
            ELSE BEGIN
               IF @P_NRTIPOCUSTO IN (10,48) BEGIN    /*Custo de Cotao(Lista de Preos com Imposto)*/
                  SET @V_VRCUSTO     = @V_VRCUSLIPRIMP;
                  SET @V_SEM_IMPOSTO = @V_VRCUSPRLISTP;
                  IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                     IF @P_NRTIPOCUSTO = 48  BEGIN
                        IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                           SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                        END;

                        IF (@V_VRPECUSTOLOG > 0) BEGIN
                           SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                        END;

                        IF (@V_VRPESEGURLOG > 0) BEGIN
                           SET @V_VRCUSTOSEG = (@V_SEM_IMPOSTO * @V_VRPESEGURLOG)/100;
                        END;

                        SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                     END;
                  END;
               END
               ELSE BEGIN
                  IF @P_NRTIPOCUSTO IN (30,61) BEGIN       /*Custo de Cotao (Lista de Preos) (ndice 01)*/
                     SET @V_VRCUSTO = @V_VRCUSPRLISM1;
                     IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                        IF @P_NRTIPOCUSTO = 61  BEGIN
                           IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                              SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                           END;

                           IF (@V_VRPECUSTOLOG > 0) BEGIN
                              SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                           END;

                           IF (@V_VRPESEGURLOG > 0) BEGIN
                              SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                           END;

                           SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF @P_NRTIPOCUSTO IN (31, 62) BEGIN       /*Custo de Cotao (Lista de Preos) (ndice 02)*/
                        SET @V_VRCUSTO = @V_VRCUSPRLISM2;
                        IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                           IF (@P_NRTIPOCUSTO = 62)  BEGIN
                              IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                                 SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                              END;

                              IF (@V_VRPECUSTOLOG > 0) BEGIN
                                 SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                              END;

                              IF (@V_VRPESEGURLOG > 0) BEGIN
                                 SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                              END;

                              SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                           END;
                        END;
                     END
                     ELSE BEGIN
                        IF @P_NRTIPOCUSTO IN (32,59) BEGIN       /*Custo da ltima Compra(AF) (ndice 01)*/
                           SET @V_VRCUSTO = @V_VRPRCUSAFM1;
                           IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                              IF @P_NRTIPOCUSTO = 59  BEGIN
                                 IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                                    SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                                 END;

                                 IF (@V_VRPECUSTOLOG > 0) BEGIN
                                    SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                                 END;

                                 IF (@V_VRPESEGURLOG > 0) BEGIN
                                    SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                                 END;

                                 SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                              END;
                           END;
                        END
                        ELSE BEGIN
                           IF @P_NRTIPOCUSTO IN (33,60) BEGIN       /*Custo da ltima Compra(AF) (ndice 02)*/
                              SET @V_VRCUSTO = @V_VRPRCUSAFM2;
                              IF ISNULL(@V_VRCUSTO, 0) > 0 BEGIN
                                 IF @P_NRTIPOCUSTO = 60  BEGIN
                                    IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                                       SET @V_VRCUSTOLOG = (@V_VRPESOBRUTPR * @V_VRVRCUSTOLOG)/@V_VRFATOCONV;
                                    END;

                                    IF (@V_VRPECUSTOLOG > 0) BEGIN
                                       SET @V_VRCUSTOLOG = (@V_VRCUSTO * @V_VRPECUSTOLOG)/100;
                                    END;

                                    IF (@V_VRPESEGURLOG > 0) BEGIN
                                       SET @V_VRCUSTOSEG = (@V_VRCUSTO * @V_VRPESEGURLOG)/100;
                                    END;
                                    SET @V_VRCUSTO = @V_VRCUSTO + ISNULL(@V_VRCUSTOLOG, 0) + ISNULL(@V_VRCUSTOSEG, 0);
                                 END;
                              END;
                           END;
                        END;
                     END;
                  END;
               END;
            END;
         END;
      END
      ELSE BEGIN
         IF @P_NRTIPOCUSTO IN (8,9,28,29,46,47) BEGIN /*Custos que tem valores na tabela POSESTDIA*/

            SELECT @V_VRLIQCMPPROD = MAX(ISNULL(VRLIQCMPPROD,0)),
                   @V_VRBRUCMPPROD = MAX(ISNULL(VRBRUCMPPROD,0)),
                   @V_VRLIQCMPPRM1 = MAX(ISNULL(VRLIQCMPPRM1,0)),
                   @V_VRLIQCMPPRM2 = MAX(ISNULL(VRLIQCMPPRM2,0)),
                   @V_VRCUSTLOGCMP = MAX(ISNULL(VRCUSTLOGCMP,0)),
                   @V_VRCUSTLCMPM1 = MAX(ISNULL(VRCUSTLCMPM1,0)),
                   @V_VRCUSTLCMPM2 = MAX(ISNULL(VRCUSTLCMPM2,0)),
                   @V_VRSEGULOGCMP = MAX(ISNULL(VRSEGULOGCMP,0)),
                   @V_VRSEGULCMPM1 = MAX(ISNULL(VRSEGULCMPM1,0)),
                   @V_VRSEGULCMPM2 = MAX(ISNULL(VRSEGULCMPM2,0))

             FROM CUSTOCMPPROD C,
                 (SELECT NRLANCESTQ NRLANCESTQ, CDPRODUTO, DTCUSTCMPPRO,
                         CDFILLANCEST
                    FROM CUSTOCMPPROD
                   WHERE CDFILIAL       = @P_CDFILIAL
                     AND CDPRODUTO      = @P_CDPRODUTO
                     AND DTCUSTCMPPRO   = (SELECT MAX(C.DTCUSTCMPPRO)
                                           FROM CUSTOCMPPROD C
                                           WHERE C.CDFILIAL = @P_CDFILIAL
                                             AND C.CDPRODUTO = @P_CDPRODUTO
                                             AND C.DTCUSTCMPPRO <= @P_DTREFERENCIA)) P
             WHERE C.CDPRODUTO = P.CDPRODUTO
               AND C.DTCUSTCMPPRO = P.DTCUSTCMPPRO
               AND ISNULL(C.NRLANCESTQ, 'NULL') = ISNULL(P.NRLANCESTQ, 'NULL')
               AND ISNULL(C.CDFILLANCEST, 'NULL') = ISNULL(P.CDFILLANCEST, 'NULL')
               AND CDFILIAL = @P_CDFILIAL;

            IF @P_NRTIPOCUSTO IN (8,46) BEGIN
               SET @V_VRCUSTO = @V_VRLIQCMPPROD;
               IF @P_NRTIPOCUSTO = 46 BEGIN
                  SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCUSTLOGCMP + @V_VRSEGULOGCMP;
               END;
            END
            ELSE BEGIN
               IF @P_NRTIPOCUSTO IN (9,47) BEGIN
                  SET @V_VRCUSTO = @V_VRBRUCMPPROD;

                  IF @P_NRTIPOCUSTO = 47 BEGIN
                     SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCUSTLOGCMP + @V_VRSEGULOGCMP;
                  END;
               END
               ELSE BEGIN
                  IF @P_NRTIPOCUSTO IN (28,50) BEGIN
                     SET @V_VRCUSTO = @V_VRLIQCMPPRM1;
                     IF @P_NRTIPOCUSTO = 50 BEGIN
                        SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCUSTLCMPM1 + @V_VRSEGULCMPM1;
                     END;
                  END
                  ELSE BEGIN
                     IF @P_NRTIPOCUSTO IN (29,51) BEGIN
                        SET @V_VRCUSTO = @V_VRLIQCMPPRM2;

                        IF @P_NRTIPOCUSTO = 51 BEGIN
                           SET @V_VRCUSTO = @V_VRCUSTO + @V_VRCUSTLCMPM2 + @V_VRSEGULCMPM2;
                        END;
                     END;
                  END;
               END;
            END;
         END
         ELSE BEGIN
            IF @P_NRTIPOCUSTO = 63 BEGIN /*Custos que tem valores na tabela CUSTMEDCTBL*/
               SELECT @V_VRCUSTO = ISNULL(MAX(C.VRCUSTOCTBL),0)
                 FROM CUSTMEDCTBL C, DATA D
                WHERE C.CDFILIAL = @P_CDFILIAL
                  AND C.CDPRODUTO = @P_CDPRODUTO
                  AND D.DTDATA = @P_DTREFERENCIA
                  AND C.DTCOMPCTBL = D.DTMES;
            END;
            IF @P_NRTIPOCUSTO = 64 BEGIN /*Custos que tem valores na tabela ITEMPRECOJETIVO*/
               SELECT @V_VRCUSTO = ISNULL(MIN(VRPRECOBJETIVO), 0)
                 FROM ITEMPRECOJETIVO, FILIAL
                WHERE FILIAL.CDFILIAL                = @P_CDFILIAL
                  AND ITEMPRECOJETIVO.CDFILIAL       = ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                  AND ITEMPRECOJETIVO.CDREGIAO       = FILIAL.CDREGIAO
                  AND ITEMPRECOJETIVO.CDPRODUTO      = @P_CDPRODUTO
                  AND @P_DTREFERENCIA BETWEEN ITEMPRECOJETIVO.DTINIVALITMOBJ AND ITEMPRECOJETIVO.DTFINVALITMOBJ;
            END;
         END;
      END;
   END;
   RETURN(@V_VRCUSTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CUSTO_PRODUTO','5.05.007';
GO

